; --------------------------------------------------------
; dedicated macros and equates for writing code generators
; --------------------------------------------------------

    fileinit MACRO
      .data?
        @@__hFile_@@ dd ?                           ;; file handle
        @@_buffer_@@ db 1024 dup (?)                ;; line buffer
        @_@p_buf_@_@ dd ?                           ;; buffer pointer
      .code
    ENDM

    startfile MACRO txt
      mov @@__hFile_@@, fcreate(txt)
    ENDM

    code$ MACRO arg:VARARG
      mov @_@p_buf_@_@, ptr$(@@_buffer_@@)          ;; clear buffer
      fprint @@__hFile_@@,cat$(@_@p_buf_@_@,arg)    ;; print the text to file
    ENDM

    blank MACRO
      test fwrite(@@__hFile_@@,chr$(13,10),2), eax
    ENDM

    qt equ <chr$(34)>       ; quotation mark        "
    lb equ <chr$(60)>       ; left angle bracket    <
    rb equ <chr$(62)>       ; right angle bracket   >
    xm equ <chr$(33)>       ; exclamation mark      !
    bs equ <chr$(92)>       ; backslash             \
    ob equ <chr$(40)>       ; left bracket          (
    cb equ <chr$(41)>       ; right bracket         )

    endfile MACRO
      fclose @@__hFile_@@
    ENDM
